#include "smtp.h"

extern smtpi jtin;

void smtp_out_packets_mtq(void *arg)
   {
   char *lcType;
   jpacket jp;
   int liProcess=0;
   xmlnode loJID;
   smtpp par=(smtpp) arg;
   dpacket dp=par->dp;
   instance i=par->i;
   pool p=par->tmppool;

   par->jp=jp=jpacket_new(dp->x);
   jpacket_subtype(jp);

   // read the language from AI (account information)
   loJID=smtp_roster_get_item(smtp_GetJID(p,xmlnode_get_attrib(jp->x,"from")),1);
   if (loJID!=NULL)
      par->lang=pstrdup(par->tmppool,xmlnode_get_attrib(loJID,"lang"));

   if (j_atoi(xmlnode_get_attrib(loJID,"default"),0)==1)
      xmlnode_free(loJID);

   // if language not defined, get lang from packet
   if (par->lang==NULL)
      par->lang=xmlnode_get_attrib(jp->x, "xml:lang");

   // if language not defined, get smtp default language
   if (par->lang==NULL)
      par->lang=jtin->DefaultLang;


   /* XXX check and make sure it's a message and stuff */
   lcType=xmlnode_get_attrib(dp->x,"type");

   if ((jtin->iLogDebug&4)==4)
      SMTP_DEBUG(SMTP_ZONE,"smtp getting a packet: %i, %i",jp->type,jp->subtype);

   switch(jp->type)
      {
      // is it message?
      case JPACKET_MESSAGE:
           if ((liProcess=smtp_out_packets_message(par,(char *)lcType))==0)
              smtp_ReplyError(i, jp, "message", "Not Implemented", 501);
 
           break;


      // is it presence?
      case JPACKET_PRESENCE:
           if ((liProcess=smtp_out_packets_presence(par,(char *)lcType))==0)
              smtp_ReplyError(i, jp, "presence", "Not Implemented", 501);

           break;


      // is it presence(x)?
      case JPACKET_S10N:
           if ((liProcess=smtp_out_packets_S10N(par,(char *)lcType))==0)
              smtp_ReplyError(i, jp, "presence", "Not Implemented", 501);

           break;

      // is it iq?
      case JPACKET_IQ:
           if ((liProcess=smtp_out_packets_iq(par, (char *)lcType))==0)
              smtp_ReplyError(i, jp, "iq", "Not Implemented", 501);

           break;

       
      // is it unknown packet?
      case JPACKET_UNKNOWN:
           break;

      }

   if (liProcess!=-2)
      {
      pool_free(par->tmppool);
      }

   return;
   }


// S:2005-09-01 gorila@dione.zcu.cz
result smtp_out_packets(instance i, dpacket dp, void *arg)
   {
   smtpp par;
   pool p;

   if ((jtin->iLogDebug&4)==4)
      SMTP_DEBUG(SMTP_ZONE,"smtp getting a packet: %s",xmlnode2str(dp->x));

   p=pool_new();   
   par= smtp_param_i(p,i);
   smtp_PoolsReg(0, p);

   par->dp=dpacket_copy_pool(p, dp);
   par->q=mtq_new(p);
   mtq_send(par->q, p, smtp_out_packets_mtq, (void *)par);

   pool_free(dp->p);
   return r_DONE;
   }
// E:2005-09-01 gorila@dione.zcu.cz
