#include "smtp.h"
#include <iconv.h> // http://mir.zyrianes.net/cygwin/release/libiconv/

extern smtpi jtin;

char *pcMonths[12]={"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};

char *smtp_itoa(pool p,long long liNumber)
   {
   char *lcItoA;
   lcItoA = (char*)pmalloc_x(p, 21,'\0');
   snprintf(lcItoA, 27, "%i\0",liNumber);
   return lcItoA;
   }


char *smtp_pttoa(pool p,void *liPointer)
   {
   char *lcItoA;
   lcItoA = (char*)pmalloc_x(p, 21,'\0');
   snprintf(lcItoA, 27, "%i\0",liPointer);
   return lcItoA;
   }

char *smtp_getword(char **lcChar, char *lcSep, char *lcMax)
   {
   char *lcToken;

   if (*lcChar==NULL || lcSep==NULL || lcMax==NULL)
      return NULL;

   // Get token
   lcToken=strtok(*lcChar,lcSep); // find first word
   *lcChar+=j_strlen(lcToken)+1;
   if (*lcChar>lcMax) // are out of string
      *lcChar=lcMax; 

   return lcToken;
   }

char *smtp_alltrim(char *lcChar)
   {
   char *lcXXX;

   if (!lcChar)
      return lcChar;

   // skip space at the beginning 
   lcXXX=lcChar+j_strlen(lcChar)-1;
   while (*lcChar == ' ' && lcChar<=lcXXX)
         {
         *lcChar = '\0';
         lcChar++;
         }

   // skip space at the end  
   while (*lcXXX == ' ' && lcXXX>=lcChar)
         {
         *lcXXX = '\0';
         lcXXX--;
         }
   return lcChar;
   }

char *smtp_2ws(char *lcChar)
   {
   char *lcXXX;

   if (!lcChar)
      return lcChar;

   // skip space at the beginning 
   lcXXX=lcChar+j_strlen(lcChar)-1;
   while ((*lcChar == '\r' || *lcChar == '\n' || *lcChar == '\t') && lcChar<=lcXXX)
         {
         *lcChar = ' ';
         lcChar++;
         }

   // skip space at the end  
   while ((*lcXXX == '\r' || *lcXXX == '\n' || *lcXXX == '\t') && lcXXX>=lcChar)
         {
         *lcXXX = ' ';
         lcXXX--;
         }
   return lcChar;
   }

char *smtp_lgstrim(char *lcChar)
   {
   char *lcXXX;

   if (lcChar==NULL)
      return NULL;

   // skip < at the beginning 
   lcXXX=lcChar+j_strlen(lcChar)-1;
   while (*lcChar != '<' && lcChar<=lcXXX)
         {
         lcChar++;
         }

   if (*lcChar == '<')
      {
      *lcChar = '\0';
      }

   lcXXX=lcChar=lcChar+1;

   // skip > at the end  
   lcXXX=lcChar+j_strlen(lcChar)-1;
   while (lcXXX[0] != '>' && lcXXX>=lcChar)
         {
         lcXXX--;
         }
   
   if (*lcXXX == '>')
      {
      *lcXXX = '\0';
      }
   return lcChar;
   }


char *smtp_strcasestr(char *lcWhere, char *lcWhat)
   {
   char *lcXXX;
   int liLen=j_strlen(lcWhere),liLenWhat=j_strlen(lcWhat);

   if (lcWhere==NULL || lcWhat==NULL)
      return (char *)NULL;

   lcXXX=lcWhere;
   while (lcXXX<=(lcWhere+liLen-1))
         {
         if (strncasecmp(lcXXX, lcWhat,liLenWhat)==0)
            break;

         lcXXX++;
         }

    if (lcXXX<=(lcWhere+liLen-1))
       return lcXXX;
    else
       return (char *)NULL;
    }


xmlnode out_SetReply(xmlnode loNew, xmlnode loOld)
   {
   char *lcId;
   xmlnode addresses,address,addressesN,addressN;

   xmlnode_put_attrib(loNew,"from",xmlnode_get_attrib(loOld,"to"));
   xmlnode_put_attrib(loNew,"to",xmlnode_get_attrib(loOld,"from"));
   if ((lcId=xmlnode_get_attrib(loOld,"id")))
      xmlnode_put_attrib(loNew,"id",lcId);


   // JEP-0033 stanzas
   if ((addresses=xmlnode_get_tag(loOld,"addresses?xmlns=http://jabber.org/protocol/address"))) 
      {
      // put adresses element to new node
      xmlnode_put_attrib(addressesN=xmlnode_insert_tag(loNew,"addresses"),"xmnls","http://jabber.org/protocol/address");

       // copy all childs elements to new node
      for (address = xmlnode_get_firstchild(addresses); address != NULL; address = xmlnode_get_nextsibling(address))
          {
	      if (address->type!=NTYPE_TAG)
		     continue;

		  xmlnode_put_attrib(addressN=xmlnode_insert_tag(addressesN,"address"),"jid",xmlnode_get_attrib(address,"jid"));
          xmlnode_put_attrib(addressN,"type",xmlnode_get_attrib(address,"type"));
          }
      }

   return loNew;
   }

void smtp_ReplyError(instance i, jpacket loOrig, const char *lcNodeName, const char *lcBody, int liError)
   {
   xmlnode x501, xError;
   pool p=pool_new();
   smtp_PoolsReg(11, p);

   x501= out_SetReply(xmlnode_dup_pool(p,loOrig->x),loOrig->x);
   xmlnode_put_attrib(x501,"type","error");

   xmlnode_put_attrib(xError=xmlnode_insert_tag(x501,"error"),"code",smtp_itoa(p,liError));
   xmlnode_insert_cdata(xError,lcBody,-1);

   deliver(dpacket_new(xmlnode_dup(x501)),i);
   pool_free(p);
   }


char *smtp_CMonth(int liMonth)
   {
   return pcMonths[liMonth];
   }


char *smtp_GetDateTime(char *lcDateTime)
   {
   time_t now_unixtime;
   struct tm now;

   now_unixtime = time(NULL);
   gmtime_r(&now_unixtime, &now);
   snprintf(lcDateTime, j_strlen(lcDateTime), "%04i%02i%02iT%02i:%02i:%02i\0", now.tm_year+1900, now.tm_mon+1, now.tm_mday, now.tm_hour+(now.tm_isdst/3600), now.tm_min, now.tm_sec);
   return lcDateTime;
   }

char *smtp_GetFolderFromFile(char *lcFile)
   {
   char *lcXXX;
   // skip > at the end  
   lcXXX=lcFile+j_strlen(lcFile)-1;
   while (lcXXX[0] != '/' && lcXXX>=lcFile)
         {
         lcXXX--;
         }
   
   if (*lcXXX == '/')
      {
      *lcXXX = '\0';
      }

   return lcFile;
   }




char *smtp_GetSMTPAddress(char *lcJID)
   {
   char *lcAT,*lcPercent;

   lcAT = strstr(lcJID,"@");
   *lcAT = '\0';
   lcPercent = strstr(lcJID,"%");
   if (lcPercent!=NULL)
      *lcPercent = '@';
   
   return lcJID;
   }

char *smtp_GetJID(pool p,char *lcJID)
   {
   char *lcNewJID,*lcSep;
   lcSep = strchr(lcJID,'/');
   if (lcSep!=NULL)
       *lcSep='\0';

   lcNewJID = pstrdup(p,lcJID);
   if (lcSep!=NULL)
       *lcSep='/';
   return lcNewJID;
   }


xmlnode smtp_findin_list(char *lcItem,xmlnode loItem)
   {
   // check spammers elememet in smtp section
   char *lcJID,*lcAsterix;
   int liLen;

   for (; loItem != NULL; loItem = xmlnode_get_nextsibling(loItem))
       {
       if (loItem->type!=NTYPE_TAG)
		   continue;

       lcJID=xmlnode_get_data(loItem);
       if (lcJID==NULL)
		   continue;

       lcAsterix=strchr(lcJID,'*');
	   if (lcAsterix==NULL) // it is...
           lcAsterix=strchr(lcJID,'%');
	   if (lcAsterix==NULL) // it is...
           lcAsterix=strchr(lcJID,'%');
	   if (lcAsterix==NULL) // it is...
           lcAsterix=strchr(lcJID,'@');

	   if (lcAsterix==NULL) // it is...
          {
          if (strcasecmp(lcItem,lcJID)==0)
              return loItem;
          else
              continue;
          }

       if (!*lcAsterix=='@')
          *lcAsterix='\0';
       
       liLen=j_strlen(lcJID);

       if (strncasecmp(lcItem,lcJID,liLen)!=0) // not it is...
           continue;


       return loItem;
	   }

   return NULL;
   }



void fromQP(char *string, void *byteStream)
   {
   char *binPtr = (char *)byteStream, lcChar;
   int strSize = j_strlen(string);
   int i = 0, j = 0;

   if (strSize==0)
      {
      binPtr[0] = '\0';
      return;
      }
   
   for(i = 0, j = 0; i < strSize; i++, j++)
      {
      lcChar=string[i]; // read char
      if (lcChar== '=') // escaped char
         {
         if (string[i+1]=='\r' || string[i+1]=='\n')
            {
//            binPtr[j] = ' ';
            j--;
            i=i+(((string[i+1]=='\r' && string[i+2]=='\n'))?2:1);
            }
         else
            {
            binPtr[j] = (string[i+1]-(string[i+1]<65?48:55))*16+(string[i+2]-(string[i+2]<65?48:55));
            i+=2;
            }
         }
      else
         binPtr[j] = lcChar;

      }
   binPtr[j] = '\0';

   }


void toQP(char *string, void *byteStream, int liSoftLines, const char *lcSpec)
   {
   char *binPtr = (char *)byteStream, cHEX[3]="  \0";
   int strSize = j_strlen(string);
   int i = 0, j = 0, liEnter=0, liASCII;
   int lcChar;

   if (strSize==0)
      {
      binPtr[0] = '\0';
      return;
      }

   for(i = 0, j = 0; i < strSize; i++, j++)
      {
      lcChar=string[i]; // read char

      if ((lcChar>=33 && lcChar<=60) ||
          (lcChar>=62 && lcChar<=126)) //  || lcChar==32

         if (j_strlen(lcSpec)==0 ||
            (j_strlen(lcSpec)>0 && strchr(lcSpec,lcChar)!=NULL))
           liASCII=3;
         else
           liASCII=1;
      else
         liASCII=3;

      if (liEnter+liASCII>60 && liSoftLines==1)
         {
         binPtr[j+0] = '=';
         binPtr[j+1] = 13;
         binPtr[j+2] = 10;
         j+=3;
         liEnter=0;
         }

      if (liASCII==1) // US-ASCII
         {      
         binPtr[j] = lcChar;
         liEnter++;
         }
      else
         {      
         binPtr[j] = '=';

         if (lcChar<0) 
            lcChar=lcChar+256;

         snprintf(cHEX, 2, "%2X",lcChar);

         binPtr[j+1] = cHEX[0] ;
         binPtr[j+2] = cHEX[1];


         j+=2;
         liEnter+=2;
         }

      }
   binPtr[j] = '\0';
   }


void toEscape(char *string, void *byteStream, const char *lcSpec)
   {
   char *binPtr = (char *)byteStream, cHEX[3]="  \0";
   int strSize = j_strlen(string);
   int i = 0, j = 0,liASCII;
   int lcChar;

   if (strSize==0)
      {
      binPtr[0] = '\0';
      return;
      }

   for(i = 0, j = 0; i < strSize; i++, j++)
      {
      lcChar=string[i]; // read char

      if ((lcChar>=33 && lcChar<=36) ||
          (lcChar>=38 && lcChar<=126))

         if (j_strlen(lcSpec)==0 ||
            (j_strlen(lcSpec)>0 && strchr(lcSpec,lcChar)!=NULL))
           liASCII=3;
         else
           liASCII=1;
      else
         liASCII=3;

      if (liASCII==1) // US-ASCII
         {      
         binPtr[j] = lcChar;
         }
      else
         {      
         binPtr[j] = '%';
         if (lcChar<0) 
            lcChar=lcChar+256;

         snprintf(cHEX, 2, "%2X",lcChar);

         binPtr[j+1] = cHEX[0] ;
         binPtr[j+2] = cHEX[1];

         j+=2;
         }

      }
   binPtr[j] = '\0';
   }


void fromEscape(char *string, void *byteStream)
   {
   char *binPtr = (char *)byteStream, lcChar;
   int strSize = j_strlen(string);
   int i = 0, j = 0;

   if (strSize==0)
      {
      binPtr[0] = '\0';
      return;
      }
   
   for(i = 0, j = 0; i < strSize; i++, j++)
      {
      lcChar=string[i]; // read char
      if (lcChar== '%') // escaped char
         {
         binPtr[j] = (string[i+1]-(string[i+1]<65?48:55))*16+(string[i+2]-(string[i+2]<65?48:55));
         i+=2;
         }
      else
         binPtr[j] = lcChar;
      }
   binPtr[j] = '\0';

   }

int smtp_CreateFolder(char *lcFolder)
   {
   char *lcSep, *lcStart;
   int liBackup;

   lcStart=lcFolder;
   if ((lcSep = strstr(lcFolder,"/\0"))==NULL)
      lcSep = strstr(lcFolder,"\\0");
      
   if (lcSep==NULL)
      lcStart=lcFolder;
   else
      lcStart=lcSep+1;

   while( lcStart != NULL )
        {
        if (lcSep!=NULL)
           *lcSep='\0';

        // While there are tokens in "string" 
        liBackup=mkdir(lcFolder,S_IRUSR | S_IWUSR | S_IXUSR );
        if (!(liBackup==-1 || errno == EEXIST))
            return errno;

        if (lcSep!=NULL)
           *lcSep='/';

        if (lcSep!=NULL)
           {
           // Get next token: 
           if ((lcSep = strstr(lcStart,"/\0"))==NULL)
              lcSep = strstr(lcStart,"\\0");

           if (lcSep!=NULL)
              lcStart=lcSep+1;
           }
        else
           lcStart=NULL;

        }    
   return 0;
   }


void smtp_xmlnode_move_node(xmlnode loNode, xmlnode loParentOld, xmlnode loParentNew)
   {
   if (loParentOld==NULL || loParentNew==NULL)
      return;


   xmlnode_hide(loNode);
   loNode->next=loNode->prev=NULL;
 
   if (loParentNew->firstchild==NULL)
      loParentNew->firstchild=loNode;
   else
      {
      loNode->next=loParentNew->firstchild;
      loParentNew->firstchild->prev=loNode;
      loParentNew->firstchild=loNode;
      }

   if (loParentNew->lastchild==NULL)
      loParentNew->lastchild=loNode;

   loNode->parent = loParentNew; // change parent of node
//   xmlnode2file("./spool/test2.xml",loParentNew);

    
   }



xmlnode xmlnode_get_firstcdata(xmlnode loItem)
   {
   for(loItem = xmlnode_get_firstchild(loItem); loItem != NULL; loItem = xmlnode_get_nextsibling(loItem))
      if(xmlnode_get_type(loItem) == NTYPE_CDATA) return loItem;
   return NULL;
   }



int smtp_check_list(char *lcItem,xmlnode loItem)
   {
   // check spammers elememet in smtp section
   char *lcIP,*lcAsterix;
   int liLen,liMode=-1,liModeE;

   for (; loItem != NULL; loItem = xmlnode_get_nextsibling(loItem))
       {
       if (loItem->type!=NTYPE_TAG)
		   continue;

       lcIP=xmlnode_get_attrib(loItem,"ip");
       if (lcIP==NULL)
		   continue;

       lcAsterix=strchr(lcIP,'*');
	   if (lcAsterix==NULL) // it is...
          {
          if (strcasecmp(lcItem,lcIP)==0)
              return j_atoi(xmlnode_get_attrib(loItem,"mode"),0);
          else
              continue;
          }

       liLen=j_strlen(lcIP)-( (lcAsterix- lcIP)+1 );

	   if (strcasecmp((lcItem+(j_strlen(lcItem)-liLen)),(lcAsterix+1))!=0) // not it is...
          continue;

       liMode=j_atoi(xmlnode_get_attrib(loItem,"mode"),0); // get mode
       // check exceptions mode
       liModeE=smtp_check_list(lcItem,xmlnode_get_tag(loItem,"item"));
       if (liModeE==-1)
          return -1; // if not found , exit

       return liMode!=liModeE?liModeE:liMode;
	   }

   return liMode;
   }




char* spool_print_pool(pool p,spool s)
   {
    char *ret,*tmp;
    struct spool_node *next;
    pool px;

    if(s == NULL || s->len == 0 || s->first == NULL)
        return NULL;

    if (p==NULL)
       px=s->p;
    else
       px=p;


    ret = pmalloc(px, s->len + 1);
    *ret = '\0';

    next = s->first;
    tmp = ret;
    while(next != NULL)
    {
        tmp = j_strcat(tmp,next->c);
        next = next->next;
    }

    return ret;
   }

dpacket dpacket_copy_pool(pool p, dpacket dp)
{
    dpacket p2;

    p2 = dpacket_new(xmlnode_dup_pool(p,dp->x));
    return p2;
}


int smtp_xmlnode_get_datasz(xmlnode node)
   {
   xmlnode cur;
   int iSize=0;
   if (xmlnode_get_type(node) == NTYPE_TAG) /* loop till we find a CDATA in the children */
       for (node = xmlnode_get_firstchild(node); node != NULL; node = xmlnode_get_nextsibling(node))
           if(xmlnode_get_type(node) == NTYPE_CDATA) break;

   if(node == NULL) return 0;

   for (cur = node; cur != NULL && cur->type == NTYPE_CDATA; cur = cur->next)
       iSize += cur->data_sz;

   return iSize;
   }


void smtp_xmlnode_insert_file(xmlnode node,char *file)
{
    char buf[BUFSIZ];
    int done, fd, len;

    if (NULL == file)
       return;

    fd = open(file,O_RDONLY);
    if (fd < 0)
       return;
    do {
       len = read(fd, buf, BUFSIZ);
       done = len < BUFSIZ;

       xmlnode_insert_cdata(node,buf,len);
       }while(!done);

    close(fd);
    return; /* return the xmlnode x points to */
}


char* smtp_file2base64(pool p,char *file)
   {
   char *lcBuff;
   int done, len,lii=0,liSize=BUFSIZ;
   FILE *lihFile;
   xmlnode loData=xmlnode_new_tag("data");
   char *lcData,*lcTarget;
   smtp_PoolsReg(13, xmlnode_pool(loData));

   if (NULL == file)
      return NULL;

   lcBuff= (char*) pmalloc_x(p,liSize,'\0');
   lihFile = fopen(file,"r");
   if (lihFile < 0)
      return NULL;

   do {
      len = fread( lcBuff, 1,liSize,lihFile);

      xmlnode_insert_cdata(loData,lcBuff,len);
      lii+=len;
      done = len < liSize;

      }while(!done);
   fclose(lihFile);

   lcData=xmlnode_get_data(loData);

   len=lii*3;
   lcTarget=(char*)pmalloco(p, len);
   ap_base64encode_binary(lcTarget,lcData,lii);
   
   xmlnode_free(loData);
   return lcTarget;
   }



/*
void smtp_TEST(smtpp par, jpacket loOrig)
   {
   xmlnode loConfig;
char gethx[3];
   
//   xdbcache xc;
   int liValue, liRet;
   jid ljidConfig;

   ljidConfig=jid_new(xmlnode_pool(loOrig->x),"config@-internal");

   
//   xc = xdb_cache(par->jtin->i);
   loConfig = xdb_get(par->jtin->xc,ljidConfig ,"smtp:iq:roster");

   log_debug(ZONE,"xxxxxxxxxxxxxxx      100        xxxxxxxxxxxxxxxxxxxxxxxxxxx\r\n");
   log_debug(ZONE,xmlnode2str(loConfig));
//   gets((char *)gethx);

   liValue=j_atoi(xmlnode_get_attrib(loConfig,"test"),0);
   liValue++;

   xmlnode_put_attrib(loConfig,"test",smtp_itoa(liValue));

   log_debug(ZONE,"xxxxxxxxxxxxxxx     200      xxxxxxxxxxxxxxxxxxxxxxxxxxx\r\n");
   log_debug(ZONE,xmlnode2str(loConfig));
//   gets((char *)gethx);

//int xdb_act(xdbcache xc, jid owner, char *ns, char *act, char *match, xmlnode data)
 //if(xdb_act(m->si->xc, m->user->id, NS_AUTH, "check", NULL, xmlnode_get_tag(m->packet->iq,"password")))
//   xdb_act(j->xc, j->id, "jabber:jud:users", "insert", spools(p->p,"?jid=",xmlnode_get_attrib(q,"jid"),p->p), q); // sync the xdb

//   liRet=xdb_set(par->jtin->xc, ljidConfig,"jabber:status:smtp",loConfig);
   xdb_act(par->jtin->xc, ljidConfig, "smtp:iq:roster", "check", NULL, loConfig); // sync the xdb 
   log_debug(ZONE,"xxxxxxxxxxxxxxx      300     xxxxxxxxxxxxxxxxxxxxxxxxxxx\r\nReturn value %i\r\n",liRet);

   loConfig = xdb_get(par->jtin->xc,ljidConfig ,"smtp:iq:roster");

   log_debug(ZONE,"xxxxxxxxxxxxxxx      400     xxxxxxxxxxxxxxxxxxxxxxxxxxx\r\n");
   log_debug(ZONE,xmlnode2str(loConfig));
   gets((char *)gethx);

   }
*/

char *smtp_ToUTF8(pool p, char *lcText, char *charmap)
   {

   size_t liIn,liOut,liRes;
   char *lcRet,*lcRetX;
   const char *lcInX;

   iconv_t iconv_obj;

   liIn=j_strlen(lcText);
   liOut=2*liIn+1;
//   SMTP_DEBUG(SMTP_ZONE,"xxxxxxxxxxxxxxx -   %i %i\r\n",liIn,liOut);

   lcRet = (char*)pmalloc_x(p, liOut,'\0');
   lcRetX=(char *) lcRet;
   lcInX=(char *) lcText;

//  from cp1250 to utf-8
   iconv_obj = iconv_open("UTF-8", (const char*) charmap);
//   SMTP_DEBUG(SMTP_ZONE,"xxxxxxxxxxxxxxx -   %i \r\n",(int) iconv_obj);

   if ((iconv_obj == (iconv_t) -1))
      {
      log_warn(SMTP_ZONE, "[SMTP]: Error - iconv_open returned %d",iconv_obj);
      }
   else
      {
//   SMTP_DEBUG(SMTP_ZONE,"xxxxxxxxxxxxxxx -   START");
      iconv(iconv_obj, NULL, NULL, &lcRetX, &liOut);
      liRes=iconv(iconv_obj, &lcInX, &liIn, &lcRetX, &liOut);

//   SMTP_DEBUG(SMTP_ZONE,"xxxxxxxxxxxxxxx -   END %i",liRes);
      iconv_close(iconv_obj);
      }

//   SMTP_DEBUG(SMTP_ZONE,"xxxxxxxxxxxxxxx -   %s \r\n",lcRetX);


   return lcRet;

   }


